=== debian/changelog ===
chewing-editor (0.0.1-3) unstable; urgency=medium

  * Add missing copyright for debian/*.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 10 Feb 2016 01:34:46 +0800

chewing-editor (0.0.1-2) unstable; urgency=medium

  * Bump Standards-Version to 3.9.7.
  * Update copyright.
  * Update Vcs-* fields.
  * Update package description.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 08 Feb 2016 23:17:20 +0800

chewing-editor (0.0.1-1) unstable; urgency=low

  * Initial release. Closes: #809014

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 Dec 2015 14:45:26 +0800
