## chewing-editor 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,10 +15,12 @@
 # with this program; if not, write to the Free Software Foundation, Inc.,
 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 
+# override default c/c++ flags, add /MT to link VC++ runtime statically.
+set(CMAKE_USER_MAKE_RULES_OVERRIDE	${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
+set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX	${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)
+
 cmake_minimum_required(VERSION 3.0.0)
-project(chewing-editor VERSION 0.0.0)
-
-set(TRANSLATION_LIST en_US zh_TW)
+project(chewing-editor VERSION 0.1.1)
 
 cmake_policy(SET CMP0020 NEW)
 
@@ -36,19 +38,29 @@
     if (VALGRIND)
         option(USE_VALGRIND "Use valgrind when testing" true)
     endif()
-
-    set(TRANSLATION_PATH ${CMAKE_INSTALL_DATADIR}/chewing-editor/translations)
-
-    add_definitions(-DTRANSLATION_PATH="${TRANSLATION_PATH}")
-else()
-    # FIXME: Windows TRANSLATION_PATH path is?
-    #add_definitions(-DTRANSLATION_PATH="???")
-endif()
+elseif(MSVC)
+    # MBCS is the default in msvc, overwrite to unicode
+    add_definitions(-DUNICODE -D_UNICODE)
+endif()
+
 add_definitions(-DTESTDATA="${PROJECT_SOURCE_DIR}/test/data")
 
 find_package(PkgConfig)
-
+find_package(Qt5Widgets REQUIRED)
+
+find_program(LUPDATE lupdate)
+if (NOT LUPDATE)
+    message(SEND_ERROR "Cannot find lupdate")
+endif()
+find_program(LRELEASE lrelease)
+if (NOT LRELEASE)
+    message(SEND_ERROR "Cannot find lrelease")
+endif()
+
+# libchewing
+# MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/lib/*.lib
 set(CHEWING_LIBRARIES )
+# MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/include/chewing
 set(CHEWING_INCLUDE_DIRS )
 
 if (CHEWING_INCLUDE_DIRS AND CHEWING_LIBRARIES)
@@ -59,20 +71,27 @@
     pkg_check_modules(CHEWING REQUIRED chewing>=0.4.0)
 endif()
 
-
+# Qt library
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
-find_package(Qt5Widgets REQUIRED)
-
-find_program(LUPDATE lupdate)
-if (NOT LUPDATE)
-    message(SEND_ERROR "Cannot find lupdate")
-endif()
-
-find_program(LRELEASE lrelease)
-if (NOT LRELEASE)
-    message(SEND_ERROR "Cannot find lrelease")
+# Git describe
+find_package(Git)
+if (GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git/HEAD")
+    execute_process(
+        COMMAND
+            ${GIT_EXECUTABLE}
+            describe
+            --tags
+        WORKING_DIRECTORY
+            ${PROJECT_SOURCE_DIR}
+        RESULT_VARIABLE
+            git_describe_result
+        OUTPUT_VARIABLE
+            PROJECT_GIT_VERSION
+        ERROR_QUIET
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+    )
 endif()
 
 configure_file(
@@ -87,7 +106,7 @@
 
 install(
     FILES ${PROJECT_BINARY_DIR}/chewing-editor.desktop
-    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/application
+    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications
 )
 
 include_directories(
@@ -103,6 +122,50 @@
     ${Qt5Widgets_INCLUDES}
 )
 
+include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/platform_apple.cmake)
+
+# resources
+QT5_ADD_RESOURCES(qt_resources ${PROJECT_SOURCE_DIR}/rc/resources.qrc)
+
+# i18n
+set(TRANSLATION_LIST en_US zh_TW)
+
+set(TS_DIR "${PROJECT_SOURCE_DIR}/ts")
+set(QM_DIR "${PROJECT_SOURCE_DIR}/ts")
+
+add_custom_target(prepare_lupdate
+    COMMAND ${CMAKE_COMMAND} -E make_directory ${TS_DIR}
+)
+add_custom_target(lupdate)
+
+add_custom_target(prepare_lrelease
+    COMMAND ${CMAKE_COMMAND} -E make_directory ${QM_DIR}
+)
+
+foreach(TRANSLATION ${TRANSLATION_LIST})
+    set(TS_FILE "${TS_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.ts")
+    set(QM_FILE "${QM_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.qm")
+
+    add_custom_target("${TRANSLATION}-ts"
+        COMMAND ${LUPDATE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
+        DEPENDS prepare_lupdate
+    )
+    add_dependencies(lupdate "${TRANSLATION}-ts")
+
+    add_custom_command(
+        OUTPUT
+            ${QM_FILE}
+        COMMAND ${LRELEASE} ${TS_FILE} -qm ${QM_FILE}
+        DEPENDS
+            prepare_lrelease
+            ${TS_FILE}
+    )
+    list(APPEND QM_FILES ${QM_FILE})
+endforeach()
+
+add_custom_target(lrelease ALL DEPENDS ${QM_FILES})
+QT5_ADD_RESOURCES(qt_resources ${PROJECT_SOURCE_DIR}/ts/ts.qrc)
+
 # exporter
 file(GLOB_RECURSE exporter_src ${PROJECT_SOURCE_DIR}/src/exporter/*)
 add_library(exporter STATIC ${exporter_src})
@@ -130,61 +193,40 @@
     ${PROJECT_SOURCE_DIR}/src/view/*
     ${ui}
 )
-add_executable(chewing-editor ${chewing-editor_src})
+add_executable(chewing-editor WIN32 ${MACOSX_APP} ${chewing-editor_src} ${qt_resources} ${PROJECT_SOURCE_DIR}/rc/chewing-editor.rc) # on Windows, remove "WIN32" for a console window
 target_link_libraries(chewing-editor
     ${CHEWING_LIBRARIES}
     exporter
     importer
     util
 )
+if(MSVC)
+    target_link_libraries(chewing-editor  # append libraries
+        Qt5::Widgets
+        "${_qt5Widgets_install_prefix}/lib/qtpcre.lib"
+        "${_qt5Widgets_install_prefix}/lib/qtfreetype.lib"
+        "${_qt5Widgets_install_prefix}/lib/qtharfbuzzng.lib"
+        "${_qt5Widgets_install_prefix}/lib/Qt5PlatformSupport.lib"
+        "${_qt5Widgets_install_prefix}/plugins/platforms/qwindows.lib"
+        imm32.lib
+        winmm.lib
+        Ws2_32.lib
+    )
+endif()
+
 qt5_use_modules(chewing-editor Widgets)
 install(PROGRAMS ${CMAKE_BINARY_DIR}/chewing-editor DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 # icon
 install(FILES ${CMAKE_SOURCE_DIR}/share/icons/chewing-editor.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
-
-# i18n
-set(TS_DIR "${PROJECT_SOURCE_DIR}/ts")
-set(QM_DIR "${PROJECT_BINARY_DIR}/qm")
-
-add_custom_target(prepare_lupdate
-    COMMAND ${CMAKE_COMMAND} -E make_directory ${TS_DIR}
-)
-add_custom_target(lupdate)
-
-add_custom_target(prepare_lrelease
-    COMMAND ${CMAKE_COMMAND} -E make_directory ${QM_DIR}
-)
-
-foreach(TRANSLATION ${TRANSLATION_LIST})
-    set(TS_FILE "${TS_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.ts")
-    set(QM_FILE "${QM_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.qm")
-
-    add_custom_target("${TRANSLATION}-ts"
-        COMMAND ${LUPDATE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
-        DEPENDS prepare_lupdate
-    )
-    add_dependencies(lupdate "${TRANSLATION}-ts")
-
-    add_custom_command(
-        OUTPUT
-            ${QM_FILE}
-        COMMAND ${LRELEASE} ${TS_FILE} -qm ${QM_FILE}
-        DEPENDS
-            prepare_lrelease
-            ${TS_FILE}
-    )
-    list(APPEND QM_FILES ${QM_FILE})
-endforeach()
-
-add_custom_target(lrelease ALL DEPENDS ${QM_FILES})
-install(FILES ${QM_FILES} DESTINATION ${TRANSLATION_PATH})
+install(FILES ${CMAKE_SOURCE_DIR}/rc/chewing-editor.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256/apps)
 
 # manpage
 find_program(HELP2MAN help2man)
+find_program(GZIP gzip)
 
 if (HELP2MAN)
-    set(manpage ${PROJECT_BINARY_DIR}/chewing-editor.1.gz)
+    set(manpage ${PROJECT_BINARY_DIR}/chewing-editor.1)
     set(h2m ${PROJECT_SOURCE_DIR}/chewing-editor.h2m)
 
     add_custom_command(
@@ -202,6 +244,20 @@
             ${h2m}
     )
 
+    if (GZIP)
+        add_custom_command(
+            OUTPUT
+                ${manpage}.gz
+            COMMAND ${GZIP}
+                -f
+                ${manpage}
+            DEPENDS
+                ${manpage}
+        )
+
+        set(manpage ${manpage}.gz)
+    endif()
+
     add_custom_target(manpage ALL DEPENDS ${manpage})
 
     install(FILES ${manpage} DESTINATION "${CMAKE_INSTALL_MANDIR}/man1/")
@@ -223,6 +279,7 @@
     exporter
     importer
     util
+    pthread
 )
 qt5_use_modules(run-test Widgets)
