=== debian/changelog ===
chewing-editor (0.1.1-6) unstable; urgency=medium

  * Team upload.
  * debian/control: Update build-dependency pkg-config => pkgconf.
  * debian/upstream/metadata: Added following Debian Janitor MR.
  * debian/control: Update build-dependency requirement following
    Debian Janitor MR.

 -- Boyuan Yang <byang@debian.org>  Thu, 04 Jul 2024 22:06:06 -0400

chewing-editor (0.1.1-5) unstable; urgency=medium

  * Team upload.
  * debian/clean: Manually clean generated .qm files to avoid
    fails to build source after successful build. (Closes: #1043646)

 -- Boyuan Yang <byang@debian.org>  Sun, 13 Aug 2023 09:50:50 -0400

chewing-editor (0.1.1-4) unstable; urgency=medium

  * Team upload.
  * Backport upstream trunk code till 2020-10-20.
  * Refresh packaging:
    + Bump Standards-Version to 4.6.1.
    + Bump debhelper compat to v13.
  * debian/rules: Drop useless "dh_missing --fail-missing" with dh13.
  * debian/uscan: Fix upstream monitoring.
  * debian/source/local-options: Dropped, useless.

 -- Boyuan Yang <byang@debian.org>  Sun, 18 Sep 2022 15:25:55 -0400

chewing-editor (0.1.1-3) unstable; urgency=medium

  * Team upload.
  * debian/patches: Backport upstream trunk code till 2017-05-30.
  * debian/control:
    + Bump debhelper compat to v11.
    + Bump Standards-Version to 4.2.1.
    + Update Vcs fields and use the repo under debian input-method-team.
  * debian/rules: Use "dh_missing --fail-missing".
  * debian/copyright: Use secure uri.

 -- Boyuan Yang <byang@debian.org>  Tue, 04 Sep 2018 15:20:29 -0400

chewing-editor (0.1.1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.4.
    * Change to https in Format in d/copyright.
  * Bump compat to 11.
  * Update Maintainer mail address. (Closes: #899471)
  * Update Vcs-* fields to salsa.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 29 May 2018 23:04:28 +0800

chewing-editor (0.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 24 Apr 2016 19:45:36 +0800

chewing-editor (0.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.8.
  * Update Vcs-* fields.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 16 Apr 2016 14:53:16 +0800

chewing-editor (0.0.4-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 04 Apr 2016 18:04:21 +0800

chewing-editor (0.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 25 Mar 2016 19:29:21 +0800

chewing-editor (0.0.2-1) unstable; urgency=medium

  * New upstream release. Closes: #814308
  * Remove unused version patch.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 05 Mar 2016 00:05:51 +0800
