=== debian/control ===
Source: chewing-editor
Section: x11
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 help2man,
 libchewing3-dev,
 pkgconf,
 qtchooser,
 qttools5-dev,
 qttools5-dev-tools,
Standards-Version: 4.7.0
Homepage: https://github.com/chewing/chewing-editor
Vcs-Git: https://salsa.debian.org/input-method-team/chewing-editor.git
Vcs-Browser: https://salsa.debian.org/input-method-team/chewing-editor

Package: chewing-editor
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: user dictionary editor for the chewing input method
 chewing-editor is a cross platform user dictionary editor for the chewing
 input method. It provides an easy way to customize user dictionary so that
 chewing input method can take advantage of the user dictionary and provide a
 better input experience.
