## chewing-editor 0.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,19 +19,19 @@
 set(CMAKE_USER_MAKE_RULES_OVERRIDE	${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
 set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX	${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)
 
-cmake_minimum_required(VERSION 3.0.0)
-project(chewing-editor VERSION 0.1.1)
-
-cmake_policy(SET CMP0020 NEW)
+cmake_minimum_required(VERSION 3.10.0...3.31.6)
+project(chewing-editor VERSION 0.1.2 LANGUAGES CXX)
+
+set(CMAKE_CXX_STANDARD 17)
 
 include(GNUInstallDirs)
 
-if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
-    set(CMAKE_CXX_FLAGS "-std=c++11 -g -O2 ${CMAKE_CXX_FLAGS}")
+if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU" OR ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
+    set(CMAKE_CXX_FLAGS "-g -O2 ${CMAKE_CXX_FLAGS}")
 
     option(ENABLE_GCOV "Coverage support" false)
     if(ENABLE_GCOV)
-        set(CMAKE_CXX_FLAGS "-coverage ${CMAKE_CXX_FLAGS}")
+        set(CMAKE_CXX_FLAGS "--coverage ${CMAKE_CXX_FLAGS}")
     endif()
 
     find_program(VALGRIND valgrind)
@@ -43,27 +43,21 @@
     add_definitions(-DUNICODE -D_UNICODE)
 endif()
 
-add_definitions(-DTESTDATA="${PROJECT_SOURCE_DIR}/test/data")
+add_definitions(-DTESTDATA="${PROJECT_SOURCE_DIR}/test/data" -DQT_DISABLE_DEPRECATED_BEFORE=0x050e00)
 
 find_package(PkgConfig)
 find_package(Qt5Widgets REQUIRED)
-
-find_program(LUPDATE lupdate)
-if (NOT LUPDATE)
-    message(SEND_ERROR "Cannot find lupdate")
-endif()
-find_program(LRELEASE lrelease)
-if (NOT LRELEASE)
-    message(SEND_ERROR "Cannot find lrelease")
-endif()
+find_package(Qt5LinguistTools)
 
 # libchewing
+# MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/lib/
+set(CHEWING_LIBRARY_DIRS )
 # MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/lib/*.lib
 set(CHEWING_LIBRARIES )
 # MODIFY IF NEEDED, e.g. ${CMAKE_CURRENT_SOURCE_DIR}/libchewing/include/chewing
 set(CHEWING_INCLUDE_DIRS )
 
-if (CHEWING_INCLUDE_DIRS AND CHEWING_LIBRARIES)
+if (CHEWING_INCLUDE_DIRS AND CHEWING_LIBRARIES AND CHEWING_LIBRARY_DIRS)
     # if all listed variables are TRUE
     find_package_handle_standard_args(chewing DEFAULT_MSG CHEWING_LIBRARIES CHEWING_INCLUDE_DIRS)
     mark_as_advanced(CHEWING_LIBRARIES CHEWING_INCLUDE_DIRS)
@@ -71,9 +65,12 @@
     pkg_check_modules(CHEWING REQUIRED chewing>=0.4.0)
 endif()
 
+pkg_check_modules(GTEST REQUIRED gtest>=1.7.0 IMPORTED_TARGET)
+
 # Qt library
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
+set(QT_VERSION 5)
 
 # Git describe
 find_package(Git)
@@ -99,19 +96,13 @@
     ${PROJECT_BINARY_DIR}/include/config.h
 )
 
-configure_file(
-    ${PROJECT_SOURCE_DIR}/chewing-editor.desktop.in
-    ${PROJECT_BINARY_DIR}/chewing-editor.desktop
-)
-
 install(
-    FILES ${PROJECT_BINARY_DIR}/chewing-editor.desktop
+    FILES ${PROJECT_SOURCE_DIR}/chewing-editor.desktop
     DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications
 )
 
 include_directories(
     ${PROJECT_BINARY_DIR}/include
-    ${PROJECT_SOURCE_DIR}/gmock/gtest/include
     ${PROJECT_SOURCE_DIR}/src/exporter
     ${PROJECT_SOURCE_DIR}/src/importer
     ${PROJECT_SOURCE_DIR}/src/model
@@ -122,6 +113,8 @@
     ${Qt5Widgets_INCLUDES}
 )
 
+link_directories(${CHEWING_LIBRARY_DIRS})
+
 include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/platform_apple.cmake)
 
 # resources
@@ -147,7 +140,7 @@
     set(QM_FILE "${QM_DIR}/${CMAKE_PROJECT_NAME}_${TRANSLATION}.qm")
 
     add_custom_target("${TRANSLATION}-ts"
-        COMMAND ${LUPDATE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
+        COMMAND ${Qt5_LUPDATE_EXECUTABLE} ${PROJECT_SOURCE_DIR}/src -ts ${TS_FILE}
         DEPENDS prepare_lupdate
     )
     add_dependencies(lupdate "${TRANSLATION}-ts")
@@ -155,7 +148,7 @@
     add_custom_command(
         OUTPUT
             ${QM_FILE}
-        COMMAND ${LRELEASE} ${TS_FILE} -qm ${QM_FILE}
+        COMMAND ${Qt5_LRELEASE_EXECUTABLE} ${TS_FILE} -qm ${QM_FILE}
         DEPENDS
             prepare_lrelease
             ${TS_FILE}
@@ -169,12 +162,12 @@
 # exporter
 file(GLOB_RECURSE exporter_src ${PROJECT_SOURCE_DIR}/src/exporter/*)
 add_library(exporter STATIC ${exporter_src})
-qt5_use_modules(exporter Widgets)
+target_link_libraries(exporter Qt5::Widgets)
 
 # importer
 file(GLOB_RECURSE importer_src ${PROJECT_SOURCE_DIR}/src/importer/*)
 add_library(importer STATIC ${importer_src})
-qt5_use_modules(importer Widgets)
+target_link_libraries(importer Qt5::Widgets)
 
 # ui
 file(GLOB ui_src ${PROJECT_SOURCE_DIR}/src/ui/*)
@@ -183,7 +176,7 @@
 # util
 file(GLOB util_src ${PROJECT_SOURCE_DIR}/src/util/*)
 add_library(util STATIC ${util_src})
-qt5_use_modules(util Widgets)
+target_link_libraries(util Qt5::Widgets)
 
 # chewing-editor
 file(GLOB chewing-editor_src
@@ -214,12 +207,12 @@
     )
 endif()
 
-qt5_use_modules(chewing-editor Widgets)
+target_link_libraries(chewing-editor Qt5::Widgets)
 install(PROGRAMS ${CMAKE_BINARY_DIR}/chewing-editor DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 # icon
 install(FILES ${CMAKE_SOURCE_DIR}/share/icons/chewing-editor.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
-install(FILES ${CMAKE_SOURCE_DIR}/rc/chewing-editor.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256/apps)
+install(FILES ${CMAKE_SOURCE_DIR}/rc/chewing-editor.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps)
 
 # manpage
 find_program(HELP2MAN help2man)
@@ -249,7 +242,7 @@
             OUTPUT
                 ${manpage}.gz
             COMMAND ${GZIP}
-                -f
+                -n -f
                 ${manpage}
             DEPENDS
                 ${manpage}
@@ -265,7 +258,6 @@
 
 # testing
 enable_testing()
-add_subdirectory(gmock)
 
 file(GLOB run-test_src
     test/*.cpp
@@ -274,14 +266,14 @@
     ${run-test_src}
 )
 target_link_libraries(run-test
-    gmock
+    PkgConfig::GTEST
 
     exporter
     importer
     util
     pthread
 )
-qt5_use_modules(run-test Widgets)
+target_link_libraries(run-test Qt5::Widgets)
 
 add_test(test run-test)
 
@@ -296,6 +288,8 @@
 set(CPACK_SOURCE_GENERATOR TGZ)
 set(CPACK_SOURCE_IGNORE_FILES
     "^${PROJECT_SOURCE_DIR}/.git"
+    "^${PROJECT_SOURCE_DIR}/.jj"
+    "^${PROJECT_SOURCE_DIR}/build"
 )
 
 set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
