=== debian/changelog ===
chewing-editor (0.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Use upstream manpage.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 27 Jul 2025 01:58:39 +0800
