=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
  debhelper-compat (= 13),
  help2man,
  libchewing3-dev,
+ libgtest-dev,
  pkgconf,
  qtchooser,
  qttools5-dev,
