=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,3 @@
 
 %:
 	dh $@
-
-execute_after_dh_auto_install:
-	rm -r debian/chewing-editor/usr/share/man
